
:- ensure_loaded( '../../src/init_lib' ).

:- requires( opts_select_infiles/3 ).
:- requires( option_required/2 ).

multiply_class( Opts ) :-
	opts_select_infiles( Opts, Fs, NFOpts ),
	option_required( class(Cl), NFOpts ),
	option_required( by(By), NFOpts ),
	multiply_class_1( Fs, Cl, By ).

multiply_class_1( [], _Cl, _By ).
multiply_class_1( [H,S|T], Cl, By ) :-
	write( doing_file(H) ), nl,
	write( writing_on(S) ), nl,
	open( H, read, In ),
	open( S, write, Out ),
	read( In, Fst ),
	multiply_class_in_with_streams( Fst, In, Cl, By, Out ),
	close( Out ),
	close( In ),
	multiply_class_1( T, Cl, By ).

multiply_class_in_with_streams( end_of_file, _In, _Cl, _By, _Out ) :-
	!.
multiply_class_in_with_streams( Term, In, Cl, By, Out ) :-
	functor( Term, Name, Arity ),
	( Name == data -> 
		arg( Arity, Term, TClass ),
		( TClass == Cl -> N is By ; N is 1),
		write_n_times_on_stream( N, Out, Term )
		;
		writeq( Out, Term ), write( Out, '.' ), nl( Out )
	),
	read( In, NxTrm ),
	multiply_class_in_with_streams( NxTrm, In, Cl, By, Out ).

write_n_times_on_stream( 0, _Out, _Term ) :- !.
write_n_times_on_stream( N, Out, Term ) :-
	writeq( Out, Term ), write( Out, '.' ), nl( Out ),
	Nm is N - 1,
	write_n_times_on_stream( Nm, Out, Term ).
