:- ensure_loaded( '../src/init_lib' ).

% REQUIRES data to be loaded...
mvis_to_fterms( FileIn, ModType, FileOut ) :-
	once( modtype_loads( ModType, RedModName, Aux )  ),
	open( FileIn, read, In ),
	open( FileOut, write, Out ),
	read( In, MvisTerm ),
	stream_mvis_terms_to_fterms_out( MvisTerm, In, RedModName, Aux, Out ),
	close( In ), 
	close( Out ).

stream_mvis_terms_to_fterms_out( end_of_file, _In, _ModType, _Aux, _Out ) :- !.
stream_mvis_terms_to_fterms_out( InTerm, In, ModType, Aux, Out ) :-
	InTerm = Tms-c(M),
	once( get_model_llhood( ModType, M, Aux, LLM, Metric ) ),
	writeq( Out, st(Tms,LLM,Metric,M) ), write( Out, '.' ), nl( Out ),
	read( In, NxTrm ),
	stream_mvis_terms_to_fterms_out( NxTrm, In, ModType, Aux, Out ).

get_model_llhood( cart_red, M, Ids, LLM, MissCl ) :-
	!,
	red_cart_to_full( M, 0, Ids, FullM ), 
		% Prb, root Depth=0, but not used anyways.
	model_llhood( FullM, LLM ),
	cart_misclassifications( FullM, MissCl ).
get_model_llhood( ModType, M, _, LLM, Metric ) :-
	model_llhood( M, LLM ),
	once( modtype_metric( ModType, M, Metric ) ).

modtype_loads( cart, cart, null ) :-
	elm( 'carts/src/lhood' ),
	elm( 'carts/auxil/cart_misclassifications' ).
modtype_loads( cart_red(_), cart_red, Ids ) :-
	elm( 'carts/auxil/red_cart_to_full' ),
	once( modtype_loads(cart,_,_) ),
	bb_get( idsd_put, t(_NofF,_DataSet,_Splits,Ids) ).
modtype_loads( ped, ped, null ) :-
	elm( 'pedigree/src/ped_likelihood' ).

modtype_metric( cart, M, MissCl ) :-
	cart_misclassifications( M, MissCl ).
modtype_metric( Type, _M, AbsntM ) :-
	Type \== cart,
	AbsntM = [].
