:- ensure_loaded( library(lists) ).		% memberchk/2.

:- ensure_loaded( '../../src/init_lib' ).
:- ensure_loaded( library(break_nth) ).

count_data_corr( Opts ) :-
	( Opts == help; Opts == h; memberchk(h,Opts); memberchk(help,Opts)),
	!,
	write( 'count_data_corr:   counts data correlation between two data points' ), nl, nl,
	write( ' Options: ' ), nl,
	write( '      i/1,    the indices for the points. Two should be given.' ),
	% write( '      n/1,    number of total data points.' ), nl,
	write( '      file/1,    file(s) where data resides.' ), nl.

count_data_corr( Opts ) :-
	findall( I, member(i(I),Opts), [Frs,Sec|_] ),
	sort( [Frs,Sec], [L,H] ),
	D is H - L,
	findall( F, member(file(F),Opts), Fs ),
	nl,
	count_data_corr_in_files( Fs, L, D ),
	nl.

count_data_corr_in_files( [], _, _ ).
count_data_corr_in_files( [File|Fs], L, H ) :-
	open( File, read, In ),
	read( In, T ),
	count_data_corr_1( T, In, c(0,0,0,0), L, H, Res ),
	% count_data_corr_1( T, In, c((0,0)-0,(0,1)-0,(1,0)-0,(1,1)-0), Res ),
	close( In ),
	write( file(File)-counters(Res) ), nl,
	count_data_corr_in_files( Fs, L, H ).


count_data_corr_1( end_of_file, _In, Res, _L, _H, Res ) :- !.
count_data_corr_1( T, In, Acc, L, H, Res ) :-
	T =.. [data|Args],
	write( 'I think defn of break_nth_has_changed use L-1 and H-1' ), nl,
	break_nth( L, Args, _, [LPnt|Right] ),
	break_nth( H, Right, _, [HPnt|_] ),
	update_couter( LPnt, HPnt, Acc, NxAcc ),
	read( In, NxT ), 
	count_data_corr_1( NxT, In, NxAcc, L, H, Res ).

update_couter( 0, 0, c(In,V1,V2,V3), c(Out,V1,V2,V3) ) :- !, Out is In + 1.
update_couter( 0, 1, c(V1,In,V2,V3), c(V1,Out,V2,V3) ) :- !, Out is In + 1.
update_couter( 1, 0, c(V1,V2,In,V3), c(V1,V2,Out,V3) ) :- !, Out is In + 1.
update_couter( 1, 1, c(V1,V2,V3,In), c(V1,V2,V3,Out) ) :- Out is In + 1.
