/* 
To display samples from an SLP genetor, do 
		% cd auxil; prolog
		?- [disp_from].
		?- disp_from( <Order>, <basename> ). 
			% (eg. disp_from( or, bn_or_2p). )
		     % where ../slp/bn_or_2p.slp is an existing file
			% use Order = un, for unordered runs.
*/

:- ensure_loaded( '../mcmcms' ).
:- ensure_loaded( library(flatoms) ).
:- ensure_loaded( library(bn_to_dot_dag) ).

% disp_from( bn_or_2p ).

disp_from( Ord, File ) :-
	flatoms( ['../slp/',File,'.slp'], Complete ),
	all_dynamic( Complete ),
	ad_to_slp( [tmp('slp_transformed.pl')] ),
	( Ord == or -> 
		disp_or ; disp_un ).

disp_inf_from( Ord, File ) :-
	flatoms( ['../slp/',File,'.slp'], Complete ),
	all_dynamic( Complete ),
	ad_to_slp( [tmp('slp_transformed.pl')] ),
	repeat,
	( Ord == or -> 
		disp_or ; disp_un ),
	fail.


disp_or :-
	slp:bn( _Id, _T/[], _S/[], [1,4,2,5,6,3,7,8], Bn ),
	write( Bn ), nl,
	bn_to_dot_dag( Bn, Bn, tmp_dag ),
	system( './disp_dag tmp_dag' ).

disp_un :-
	slp:bn( _Id, _T/[], _S/[], [1,2,3,4,5,6,7,8], Bn ),
	write( Bn ), nl,
	bn_to_dot_dag( Bn, Bn, tmp_dag ),
	system( './disp_dag tmp_dag' ).

 % repeat, A = loop, disp, fail.
