
/*
     select edges that pass a cut off 
     default looks for sum of both directions

     upsh /home/nicos/islp/mcmcms/bns/auxil/edge_counts_select.pl tr_uc_rm_binari_freq_vanSteensel_bin_i500K__s221.ecounts 0.9

     */

:- requires( read_terms/2 ).

edge_counts_select( [File,Cutoff] ) :-
     edge_counts_select( File, Cutoff, Sel ),
     findall( S, (member(S,Sel),write(S),nl), _ ),
     length( Sel, L ),
     write( length(L) ), nl.

edge_counts_select( File, Cutoff, Selects ) :-
     file_to_edge_count_trips( File, Trips ),
     edge_trips_select( Trips, Cutoff, Selects, _Comb ).

file_to_edge_count_trips( File, Trips ) :-
     read_terms( File, ECs ),
     findall( X-Y-W, ( 
                         member( ec(X,Tot,Ys), ECs ),
                         nth( Y, Ys, Tms ),
                         X \== Y,
                         W is Tms / Tot
                     ),
                         Trips ).

edge_trips_select( [], _Cutoff, [], [] ).
edge_trips_select( [X-Y-W1|T], Cutoff, Sel, Comb ) :-
     select( Y-X-W2, T, R ),
     W is W1 + W2,
     ( W >= Cutoff -> 
          Comb = [X-Y-W|TComb],
          ( W1 >= Cutoff ->
               Sel = [X-Y-W1|Sel1]
               ;
               Sel = Sel1
          ),
          ( W2 >= Cutoff -> 
               Sel1 = [Y-X-W2|Sel2]
               ;
               Sel2 = Sel1
          ),
          ( (W1 < Cutoff, W2 < Cutoff) -> 
               Sel2 = [X-Y-W1,Y-X-W2|TSel]
               ;
               Sel2 = TSel
          )
          % write( X-Y-W1-W2 ), nl,
          % Sel = [X-Y-W1-W2|TSel]
          ;
          Comb = TComb,
          Sel = TSel
     ),
     edge_trips_select( R, Cutoff, TSel, TComb ).
