/* 
   Yet another take on creating edge counts. 
   Use .mvisits files, that already has the visits counter for each BN. 
   This probably duplicatios work...

     mvisits_to_edge_counts( '/home/nicos/islp/mcmcms/bns/vanSteensel/out_vrun_v/tr_uc_rm_binari_freq_vanSteensel_bin_i5K__s308.mvisits' ).
   */

:- ensure_loaded( library(lists) ).
:- requires( to_list/2 ).

mvisits_to_edge_counts( File ) :-
     to_list( File, Files ),
     mvisit_files_to_edge_counts( Files ).

mvisit_files_to_edge_counts( [] ).
mvisit_files_to_edge_counts( [File|T] ) :-
     file_name_extension( Stem, mvisits, File ),
     file_name_extension( Stem, ecounts, Elif ),
     open( File, read, In ),
     read( In, First ),
     First = _Tms-c(Bn),
     findall( 0, member(_,Bn), Zeros ),
     findall( N-Zeros, member(N-_Pas,Bn), Ecounts ),
     % findall( X-Zeros, select(X,Nodes,Y), Ecounts ),
     mvisits_to_edge_counts_stream( First, Ecounts, 0, In, Counts, Tot ),
     close( In ),
     write( File:tot(Tot) ), nl,
     open( Elif, write, Out ),
     write_edge_counts( Counts, Tot, Out ),
     close( Out ),
     mvisit_files_to_edge_counts( T ).

write_edge_counts( [], _Tot, _Out ).
write_edge_counts( [Nd-Counts|T], Tot, Out ) :-
     write( Out, ec(Nd,Tot,Counts) ), write( Out, '.' ), nl( Out ),
     write_edge_counts( T, Tot, Out ).

mvisits_to_edge_counts_stream( end_of_file, Counts, Tot, _In, Counts, Tot ) :- !.
mvisits_to_edge_counts_stream( eof, Counts, Tot, _In, Counts, Tot ) :- !.
mvisits_to_edge_counts_stream( Tms-c(Bn), Ecounts, Acc, In, Counts, Tot ) :-
     Nxt is Acc + Tms,
     bn_edge_counts( Bn, Tms, Ecounts, Acounts ),
     read( In, Next ),
     mvisits_to_edge_counts_stream( Next, Acounts, Nxt, In, Counts, Tot ).

bn_edge_counts( [], _Tms, [], [] ).
bn_edge_counts( [Ch-Pa|T], Tms, [Ch-ChCnts|TCnts], [Ch-NxtChCnts|TNxtCnts] ) :-
     bn_pa_counts( Pa, 1, Tms, ChCnts, NxtChCnts ),
     bn_edge_counts( T, Tms, TCnts, TNxtCnts ).

bn_pa_counts( [], _I, _Tms, Nxt, Nxt ).
bn_pa_counts( [H|T], I, Tms, [Ha|Ta], [Na|TNa] ) :-
     ( H =:= I -> 
          Na is Ha + Tms,
          F = T
          ;
          Na is Ha,
          F = [H|T]
     ),
     NxtI is I + 1,
     bn_pa_counts( F, NxtI, Tms, Ta, TNa ).
