:- ensure_loaded( n_samples ).
:- ensure_loaded( eps_n_latex_graph_freqs ).
:- ensure_loaded( '../../src/lib/kv_additive_consolidation' ).

auto :- auto({}).
auto( Args ) :-
	Samples = 10000,
	n_samples( [slp(toy),samples(Samples)|Args], Tmp, Freqs ),
	write( tmp(Tmp) ), nl,
	% write( frqs(Freqs) ), nl,
	count_leaves( Freqs, LeafFreqs ),
	kv_additive_consolidation( LeafFreqs, AddFreqs ),
	kv_to_prb_vs( AddFreqs, Samples, PrbFreqs ),
	eps_n_latex_graph_freqs( PrbFreqs, toy, 'cart(V)', 2, 'toy.slp', Tmp ).

count_leaves( [], [] ).
count_leaves( [Mod-Tms|T], [Lvs-Tms|R] ) :-
	model_has_that_many_leaves( Mod, 0, Lvs ),
	count_leaves( T, R ).

model_has_that_many_leaves( leaf, Acc, Lvs ) :- 
	!,
	Lvs is Acc + 1.
model_has_that_many_leaves( _-[L,R], Acc, Lvs ) :- 
	!,
	model_has_that_many_leaves( L, Acc, LAcc ),
	model_has_that_many_leaves( R, LAcc, Lvs ).

kv_to_prb_vs( [], _Div, [] ).
kv_to_prb_vs( [K-Vin|T], Div, [K-Vout|R] ) :-
	Vout is Vin / Div,
	kv_to_prb_vs( T, Div, R ).
