
:- ensure_loaded( test_classification ). 
		% train_loaded_and_calls/3, test_loaded/2,
:- ensure_loaded( report ). 
		% bests_on_stream/9. % this is no longer true, but there maybe other dependencies.

:- ensure_loaded( bests_in_fterms_file ). % /3.
	
:- requires( opts_select_infiles/3 ).
:- requires( option_required/2 ).

bst_in_fterms_classifies( InOpts ) :-
	opts_select_infiles( InOpts, Fs, OthOpts ),
	option_required( train(Trn), OthOpts ),
	option_required( test(Tst), OthOpts ),
	( memberchk(adj(Adj),OthOpts) -> true; Adj = bayes ),
	once(train_loaded_and_calls( Trn, Ids, ClsOpts )),
	once(test_loaded( Tst, TstData )),
	TstData = [HDatum|_],
	functor( HDatum, _, DAr ),
	append( ClsOpts, OthOpts, BstOpts ),
	bst_in_fterms_classify( Fs, Ids, Tst, TstData, DAr, Adj, BstOpts ).

bst_in_fterms_classify( [], _Ids, _Tst, _TstD, _DAr, _Adj, _ClsOpts ).
bst_in_fterms_classify( [F|Fs], Ids, Tst, TstD, DAr, Adj, ClsOpts ) :-
	bests_in_fterms_file( F, _BTmsST, BLLST ),
	BLLST = st(_BstTms,_BstLLhood,_BstMClassf,BstCart),
	cart_classifies_no_split( BstCart, Ids, TstD, DAr, Adj, _Distros, ClsfPrs ),
	( memberchk(pstv(Pstv),ClsOpts)-> true
		; ClsfPrs=[Pstv-_|_]
	),
	write( using_pstv(Pstv) ), nl,
	separate_classification_pairs( ClsfPrs, Pstv, PstvPrs, NgtvPrs ),
	atom_concat( Base, 'fterms', F ),
	atom_concat( Base, Tst, BaseTst ),
	atom_concat( BaseTst, '_pos', PosTst ),
	atom_concat( BaseTst, '_neg', NegTst ),
	to_file_period_opt( PosTst, Adj, true, PstvPrs ),
	to_file_period_opt( NegTst, Adj, true, NgtvPrs ),
	bst_in_fterms_classify( Fs, Ids, Tst, TstD, DAr, Adj, ClsOpts ).

separate_classification_pairs( [], _Pstv, [], [] ).
separate_classification_pairs( [Class-Term|Tail], Pstv, PstvPrs, NgtvPrs ) :-
	( Class == Pstv -> 
		PstvPrs = [Class-Term|TPstvPrs],
		NgtvPrs = TNgtvPrs
		;
		PstvPrs = TPstvPrs,
		NgtvPrs = [Class-Term|TNgtvPrs]
	),
	separate_classification_pairs( Tail, Pstv, TPstvPrs, TNgtvPrs ).
