:- ensure_loaded( '../../src/init_lib' ).
:- ensure_loaded( library(lists) ).		% nth/3.
:- ensure_loaded( library(charsio) ).		%.
:- ensure_loaded( library(sys_info) ).		% /2.
:- ensure_loaded( library(first_matching_term_on_stream) ).		% /2.
:- ensure_loaded( '../src/display_model' ).
:- ensure_loaded( '../src/cart_llhood' ).
:- ensure_loaded( '../auxil/cart_misclassifications' ).
:- ensure_loaded( 'fterms' ). % load_data/1

gvz_nth_gz( [Data,File,PrvFrom|T] ) :-
	load_data( Data ),
	% bcw_data( _, _ ),
	to_number( PrvFrom, From ),
	( T = [PrvFor] ->
		to_number( PrvFor, For )
		;
		For = 1
	),
	From > 0,
	atom_concat( 'gunzip ', File, Gunzip ),
	sys_info( Gunzip ),
	atom_concat( Stem, '.gz', File ),
	open( Stem, read, In ), 
	read( In, Term ),
	first_matching_term_on_stream( Term, In, c(_), First ),
	Last is From + For - 1,
	gvz_from_nth_match_term_on_stream( From, First, For, Last, In ),
	close( In ).

to_number( Prv, Number ) :-
	( atom(Prv) -> 
		atom_codes( Prv, PrvCs ),
		number_codes( Number, PrvCs )
		;
		Number = Prv
	).

gvz_from_nth_match_term_on_stream( 1, Term, For, Last, In ) :-
	!,
	gvx_next_n_matches( For, Term, Last, In ).
gvz_from_nth_match_term_on_stream( N, _InTerm, For, Last, In ) :-
	read( In, FTerm ),
	first_matching_term_on_stream( FTerm, In, c(_), NextTerm ),
	NxN is N - 1,
	gvz_from_nth_match_term_on_stream( NxN, NextTerm, For, Last, In ).

gvx_next_n_matches( For, Term, Last, In ) :-
	For > 1,
	!,
	% read( In, st(Tms,LL,Mis,M) ),
	This is Last - For,
	display_this_term( Term, This ), 
	NxFor is For - 1,
	read( In, FNxTerm ),
	first_matching_term_on_stream( FNxTerm, In, c(_), First ),
	gvx_next_n_matches( NxFor, First, Last, In ).
gvx_next_n_matches( _, Term, Last, _In ) :-
	display_this_term( Term, Last ).

display_this_term( Term, This ) :-
	Term = c(Model),
	cart_llhood( Model, LLhood ),
	cart_misclassifications( Model, Mis ),
	write_to_chars( iter(This):msclf(Mis), Codes ),
	atom_codes( Atm, Codes ),
	display_model( Atm, Model, LLhood ).
