pvars(_9041,_9042).
(:-ensure_loaded(edit_mod)).
(:-ensure_loaded(library(lists))).
(:-ensure_loaded(library(ordsets))).
move(A, B) :-
        edit(A, C),
        write(edit_done),
        nl,
        move(C, B).
move(A, B) :-
        edcart_to_concrete_cart(A, B).
edit(A, B) :-
        A=ec(C,D,E),
        write(grow(E)),
        nl,
        pmember(D, F, G),
        F=leaf(H,I,J)-K,
        variable_has_position_in_cart(C, K, L),
        split_leaf(H, I, J, K, G, M),
        B=ec(C,M,[L|E]).
edit(A, B) :-
        A=ec(C,D,E),
        write(prune(E)),
        nl,
        prunable_places(C, [], F, []),
        pmember(F, G, _),
        select(G, E, H),
        write(prune_pst(G)),
        nl,
        navigate(C, G, 0, I, _, J, K),
        I=cart(_,_,L,M,N,O),
        leaves_list_var_select(D, N, _, P),
        leaves_list_var_select(P, O, Q, R),
        Q=leaf(S,_,_),
        T is S-1,
        U=[leaf(T,L,M)-K|R],
        write(new_nd_psts(H)),
        nl,
        B=ec(J,U,H).
edit(A, B) :-
        A=ec(C,D,E),
        write(change(E)),
        nl,
        pmember(E, F, G),
        navigate(C, F, 0, H, I, J, K),
        H=cart(L,_,M,N,O,P),
        feature_choice(L, N, Q, R, S),
        pmember(R, s(T,_,_), U),
        V=[f(R,U)|S],
        removes_all_node_descendant_positions(G, F, W),
        reverse(F, X),
        Y=cart(Q,T,M,V,O,P),
        propagate_node_change(Y, M, V, X, I, D, Z, A1, K),
        append(A1, W, B1),
        write(new_nd_psts(B1)),
        nl,
        B=ec(J,Z,B1).
split_leaf(A, B, [C|D], E, F, G) :-
        H is A+1,
        pmember([C|D], f(I,J), K),
        pmember(J, s(L,M,N), O),
        P=[f(I,O)|K],
        branch(P, M, Q),
        branch(P, N, R),
        E=cart(I,L,B,[C|D],S,T),
        G=[leaf(H,M,Q)-S,leaf(H,N,R)-T|F].
feature_choice(_, A, B, C, D) :-
        pmember(A, f(B,C), D).
feature_choice(A, B, A, C, D) :-
        select(f(A,C), B, D).
propagate_node_change(A, B, C, _, D, E, F, G, A) :-
        var(A), !,
        leaves_list_var_select(E, A, _, H),
        F=[leaf(D,B,C)-A|H],
        G=[].
propagate_node_change(A, B, C, D, E, F, G, H, I) :-
        A=cart(J,K,_,_,L,M),
        feature_choice_splits_ids(J, K, N),
        ord_intersection(N, B, O, P),
        updated_ids_propagate(O, P, A, D, J, K, E, L, M, C, B, F, G, H, I).
updated_ids_propagate(A, B, _, C, D, E, F, G, H, I, J, K, L, M, N) :-
        not_vacuous(A),
        not_vacuous(B), !,
        select(f(D,O), I, P),
        select(s(E,_,_), O, Q),
        R=[f(D,Q)|P],
        branch(R, A, S),
        branch(R, B, T),
        N=cart(D,E,J,I,U,V),
        W is F+1,
        reverse(C, X),
        propagate_node_change(G, A, S, [l|C], W, K, Y, Z, U),
        propagate_node_change(H, B, T, [r|C], W, Y, L, A1, V),
        append(Z, [X|A1], M).
updated_ids_propagate(_, _, A, _, _, _, B, _, _, C, D, E, F, G, H) :-
        trace,
        sub_cart_removes_from_leaves_list(A, E, I),
        F=[leaf(B,D,C)-H|I],
        G=[].
leaves_list_var_select([A-B|C], D, E, F) :-
        B==D, !,
        E=A,
        F=C.
leaves_list_var_select([A|B], C, D, E) :-
        E=[A|F],
        leaves_list_var_select(B, C, D, F).
prunable_places(A, _, B, B) :-
        var(A), !.
prunable_places(cart(_,_,_,_,A,B), C, D, E) :-
        var(A),
        var(B), !,
        reverse(C, F),
        D=[F|G],
        prunable_places(A, [l|C], G, H),
        prunable_places(B, [r|C], H, E).
prunable_places(cart(_,_,_,_,A,B), C, D, E) :-
        prunable_places(A, [l|C], D, F),
        prunable_places(B, [r|C], F, E).
sub_cart_removes_from_leaves_list(A, B, C) :-
        var(A), !,
        leaves_list_var_select(B, A, _, C).
sub_cart_removes_from_leaves_list(cart(_,_,_,_,A,B), C, D) :-
        sub_cart_removes_from_leaves_list(A, C, E),
        sub_cart_removes_from_leaves_list(B, E, D).
(:-pvars(pmember(A,_,_),[B-length(A,B)])).
pmember([A|B], A, B).
pmember([A|B], C, [A|D]) :-
        pmember(B, C, D).
branch([], _, []).
branch([f(A,B)|C], D, E) :-
        branch_possibles(B, D, F),
        restricts(F, A, E, G),
        branch(C, D, G).
branch_possibles([], _, []).
branch_possibles([s(A,B,C)|D], E, F) :-
        ord_intersection(E, B, G),
        ord_intersection(E, C, H),
        not_vacuous_constructs(G, H, A, F, I),
        branch_possibles(D, E, I).
removes_all_node_descendant_positions([], _, []).
removes_all_node_descendant_positions([A|B], C, D) :-
        (   append(C, _, A) ->
            D=E
        ;   D=[A|E]
        ),
        removes_all_node_descendant_positions(B, C, E).
restricts([], _, A, A).
restricts([A|B], C, [f(C,[A|B])|D], D).
not_vacuous_constructs([A,B,C,D,E|F], [G,H,I,J,K|L], M, N, O) :- !,
        N=[s(M,[A,B,C,D,E|F],[G,H,I,J,K|L])|O].
not_vacuous_constructs(_, _, _, A, A).
not_vacuous([_,_,_,_,_|_]).
