% :- ensure_loaded( '../../../bns/src/llhood/logamma' ).
% 2005bb16: following should be elm(...).

/* when used by postprocessing auxils. 
:- ensure_loaded( '../../../src/lib/mcmcms_top_dir' ).
:- ensure_loaded( '../../../src/lib/elm' ).
*/

:- bb_get( mcmcms_top_dir, Dir ),
   atom_concat( Dir, '/bns/src/llhood/logamma', Lgamma ),
   ensure_loaded( Lgamma ).
:- prolog_load_context(directory,Dir), atom_concat( Dir, '/', DirSl ),
   bb_put( idsd_directory, DirSl ).
% :- ensure_loaded( data_to_split_root ).
:- elm( 'carts/slps/data_to_split_root' ).
:- elm( 'auxil/dset_has_nofeatures' ).

:- requires( werr/2 ).

% not_vacuous( [_,_,_,_,_|_] ).
not_vacuous_length( 5 ).

idsd( DataSet ) :-
     idsd( DataSet, _Splits, _Ids ).

idsd( DataSet, Splits, Ids, Lim ) :-
     % write( splits(Splits)-ids(Ids) ), nl,
	bb_get( idsd_directory, DataDir ),
	atom_concat( DataDir, DataSet, FullDataSet ),
     % NofF is no longer needed,....
	dset_has_nofeatures( FullDataSet, NofF ),
     not_vacuous_length( Lim ),
	idsd_1( NofF, DataSet, Splits, Ids, Lim ).

idsd_1( NofF, DataSet, Splits, Ids, Lim ) :-
	( bb_get(idsd_put,t(NofF,DataSet,Splits,Ids)) ->
		true
		;
		% NofArgs is NofF + 1,
		bb_get( idsd_directory, DataDir ),
		atom_concat( DataDir, DataSet, FullDataSet ),
		% ensure_loaded( FullDataSet ),
		write( user_error, ensure_loaded( FullDataSet ) ), nl( user_error ),
          /*
          ( current_predicate(data/NofArgs) ->
		     functor( Call, data, NofArgs ),
		     data_call_and_feature_list( NofF, NofArgs, Call, FList, Kat )
		     % bb_put( idsd_put, t(NofArgs,Call,FList,Kat) )
               ; 
                    % Added Aug 2007. for copeing with large arities
               ( current_predicate(data/2) ->
                    free_vars_feature_list( NofF, FList),
                    Call =.. [data,AList,Kat]
                    ;
                    throw(cannt_file_data_in_memory(2,or(NofArgs)))
               )
          ),
          */
          atom_concat( FullDataSet, '.pl', PlDataSet ),
          % write( plds(PlDataSet) ), nl,
		read_data_terms( PlDataSet, Data ),
		% write( user_error, findall( AList-Kat, Call, Data ) ), nl(user_error),
		% findall( FList-Kat, Call, Data ),
		% write( user_error, findall( FList-Kat, Call, Data ) ), nl(user_error),
		% write( user_error, data_to_split_root( Data, Splits, Ids ) ),
		data_to_split_root( Data, Splits, Ids,Lim ),
          % length( Ids, Length ),
          Ids = ids(_,Length),
          werr( done_with_the_splits:nof_ids(Length), warning ),
		% write( user_error, data_to_split_root( Data, Splits, Ids ) ),
          % nl(user_error),
		bb_put( idsd_put, t(NofF,DataSet,Splits,Ids) )
	).

data_call_and_feature_list( 0, KatPos, Call, FList, Var ) :-
	!,
	arg( KatPos, Call, Var ),
	FList = [].
data_call_and_feature_list( FromKat, KatPos, Call, [Hv|TVs], Kat ) :-
	Idx is KatPos - FromKat,
	arg( Idx, Call, Hv ),
	NxtFrom is FromKat - 1,
	data_call_and_feature_list( NxtFrom, KatPos, Call, TVs, Kat ).

free_vars_feature_list( 0, [] ) :- !.
free_vars_feature_list( I, [_H|T] ) :-
     NxI is I - 1,
     free_vars_feature_list( NxI, T ).

read_data_terms( File, Data ) :-
     open( File, read, In ),
     read( In, First ),
     read_data_terms_stream( First, In, Data ),
     close( In ).

read_data_terms_stream( end_of_file, _In, [] ) :- !.
read_data_terms_stream( data(List,Kat), In, [List-Kat|T] ) :-
     !,
     read( In, Next ),
     read_data_terms_stream( Next, In, T ).
read_data_terms_stream( Datum, In, [List-Kat|T] ) :-
     Datum =.. [data|Args],
     append( List, [Kat], Args ),
     read( In, Next ),
     read_data_terms_stream( Next, In, T ).
