% generated from greeedy R tree, trained on ICML05, 80%, training PIMA data.
% In there, population of leaf is 216,

boundary( box_pima_28, 2, -inf, 127.5 ).
boundary( box_pima_28, 8, -inf,  28.5 ).

% Declare a Dirichlet distribution for box box_pima_28
% with alpha1 = 2.0 and alpha2 = 2.0
dirichlet_dn( box_pima_28, [2.0, 2.0] ).

% Declare a multinomial distribution for box box_pima_28
% with probabilities 0.6 and 0.4
multinomial_dn( box_pima_28, [0.6, 0.4] ).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% all this will go elsewhere!

:- dynamic dirichlet_dn_cache/4.
:- dynamic multinomial_dn_cache/2.

%pre_compute_dirichlet(+Alphas,-LGAlphasSum_SumLGAlphas,-AlphasSum)
pre_compute_dirichlet(Alphas,LGAlphasSum_SumLGAlphas,AlphasSum) :-
	sum_alphas_logalphas(Alphas,0,0,AlphasSum,SumLogAlphas),
	logamma(AlphasSum,LGAlphasSum),
	LGAlphasSum_SumLGAlphas is LGAlphasSum - SumLogAlphas.

sum_alphas_logalphas([],Sum,SumLog,Sum,SumLog).
sum_alphas_logalphas([H|T],In1,In2,Out1,Out2) :-
	Mid1 is H + In1,
	logamma(H,LGH),
	Mid2 is LGH + In2,
	sum_alphas_logalphas(T,Mid1,Mid2,Out1,Out2).

do_dirichlets([]).
do_dirichlets([Box-Alphas|T]) :-
	pre_compute_dirichlet(Alphas,LGAlphasSum_SumLGAlphas,AlphasSum),
	assert(dirichlet_dn_cache(Box,Alphas,AlphasSum,LGAlphasSum_SumLGAlphas)),
	do_dirichlets(T).

do_multinomials([]).
do_multinomials([Box-Ps|T]) :-
	pre_compute_multinomial(Ps,LPs),
	assert(multinomial_dn_cache(Box,LPs)),
	do_multinomials(T).

pre_compute_multinomial([],[]).
pre_compute_multinomial([H|T],[LH|LT]) :-
	LH is log(H),
	pre_compute_multinomial(T,LT).

:-
	findall(Box-Alphas,dirichlet_dn(Box,Alphas),BAs),
	do_dirichlets(BAs),
	findall(Box-Probs,multinomial_dn(Box,Probs),BPs),
	do_multinomials(BPs).

