/* 
     Keep this version fast. Only use when wanting to classify an
     example of unknown class. Do no checking so there is no support
     for older versions of data representations.
  */

%% :- ensure_loaded( '$HOME/pl/lib/term/delim_line_to_tree' ).
%% :- ensure_loaded( library(trees) ).        % get_label/3.
:- ensure_loaded( library(matrix) ).          % matrix_get/3

:- requires( kv_transpose/2 ).
% :- requires( kvs_add/3 ).
:- requires( kvs_incr_v_by/4).
:- requires( div_list/3 ).

:- multifile( null_value/1 ).
:- dynamic( null_value/1 ).

cart_classifier_add_dominant_class( cart(F,Fv,L,R), cart(F,Fv,NwL,NwR) ) :-
     cart_classifier_add_dominant_class( L, NwL ),
     cart_classifier_add_dominant_class( R, NwR ).
cart_classifier_add_dominant_class( leaf(Distro), leaf(N,Prbs) ) :-
     kv_transpose( Distro, Trans ),
     keysort( Trans, Sort ),
     last( Sort, _Prb-Class ),
     nth( N, Distro, Class-_ ),
     kv_decompose( Distro, _Classes, Prbs ).

cart_classifies_unknown( Cart, Mtx, Res ) :-
     %% delim_line_to_tree( In, Tree ),  %% trees verion
     cart_classifies_unknown_1( Cart, Mtx, MultiRes, [] ),
     cohese_multi_classed_unknown( MultiRes, Res ).

cart_classifies_unknown_1( cart(F,Fvl,L,R), ExMtx, Res, Tail ) :-
     matrix_get(ExMtx,[0,F],ExVl),
     %% get_label(F, ExTree, ExVl), %% library(trees) version
     % nth( F, ExValues, ExVl ),    %% read .pl list  version
     ( null_value(ExVl) -> 
          cart_classifies_unknown_1( L, ExMtx, Res, MainRes ),
          Branch = R
          ;
          Res = MainRes,
          ( ExVl > Fvl ->
               Branch = R
               ;
               Branch = L
          )
     ),
     cart_classifies_unknown_1( Branch, ExMtx, MainRes, Tail ).
cart_classifies_unknown_1( leaf(Class,Distro), _ExMtx, [Class-Distro|T], T ).

cohese_multi_classed_unknown( Cl-Dst, Cl-Dst ).
cohese_multi_classed_unknown( [Cl-Dst|More], Class-Distro ) :-
     cohese_multi_classed_unknown_1( More, [Cl-1], Dst, 1, _Cls, Ds, Cnt ),
     div_list( Ds, Cnt, Distro ),
     /* This bit finds the best class by aggregation of best classes...
     kv_transpose( Cls, TmClPrs ),
     keysort( TmClPrs, SrtPrs ),
     reverse( SrtPrs, RevSrtPrs ),
     select_best_classes( RevSrtPrs, BstCls ),
     ( BstCls = [Class] ->
          true
          ;
          length( BstCls, Length ),
          Lim is Length + 1,
          random( 1, Lim, R ),
          nth( R, BstCls, Class ),
          write( user_error, random_classification_at(BstCls,Class) ), 
          nl( user_error )
     ).
     */
     Distro = [FstPrb|MrPrbs],
     max_nth( MrPrbs, FstPrb, 1, 2, Class ).

cohese_multi_classed_unknown_1( [], Cls, Ds, Cnt, Cls, Ds, Cnt ).
cohese_multi_classed_unknown_1( [Cl-ThisD|More], AcC, AcD, I, Cls, Ds, Cnt ) :-
     kvs_incr_v_by( AcC, Cl, 1, NxC ),
     lists_add( AcD, ThisD, NxD ),
     NxI is I + 1,
     cohese_multi_classed_unknown_1( More, NxC, NxD, NxI, Cls, Ds, Cnt ).

lists_add( [], [], [] ).
lists_add( [H|T], [F|M], [A|R] ) :-
     A is H + F,
     lists_add( T, M, R ).

max_nth( [], _, Nth, _I, Nth ).
max_nth( [H|T], CurrMax, CurrNth, I, Nth ) :-
     ( H > CurrMax ->
          NxtMax = H,
          NxtNth is I
          ;
          NxtMax = CurrMax,
          NxtNth = CurrNth
     ),
     NxtI is I + 1,
     max_nth( T, NxtMax, NxtNth, NxtI, Nth ).

/*
select_best_classes( [MxTm-AMxCl|T], [AMxCl|TMxCls] ) :-
     select_best_classes_1( T, MxTm, TMxCls ).
select_best_classes_1( [MxTm-AnoMxCl|T], MxTm, MxCls ) :-
     !,
     MxCls = [AnoMxCl|TMxCls],
     select_best_classes_1( T, MxTm, TMxCls ).
select_best_classes_1( _, _MxTm, [] ).
*/
