
:- pl( yap(_), ensure_loaded( '$HOME/pl/programs/r_session/r_session_yap' ) ).
:- pl( swi(_), ensure_loaded( '$HOME/pl/programs/r_session/r_session_swi' ) ).

set_up_boutros :-
     /* for debugging
     r_lib( graph ),
     r_in( source('"/usr/local/users/nicos/local/src/nem/R/mLL.R"') ),
     r_in( source('"/usr/local/users/nicos/local/src/nem/R/nem.R"') ),
     r_in( source('"/usr/local/users/nicos/local/src/nem/R/score.R"') ),
     r_in( d <- 'read.csv("/home/nicos/nki/sides/nems/mll_boutros.csv",check.names=FALSE)' ),
     */
     r_lib( nem ),
     r_in( data('"BoutrosRNAi2002"') ),
     r_in( d <- 'BoutrosRNAiDiscrete[,9:16]' ),
     % r_in( 'dim(d)' ),
     r_in( control <- 'set.default.parameters(unique(colnames(d)), para=c(0.13, 0.05))' ),
     sgenes <- unique(colnames(d)),
     r_in( 'rownames(m) <- unique(colnames(d))' ),
     r_in( 'colnames(m) <- unique(colnames(d))' ),
     % r_in( 'sgenes <- setdiff(unique(colnames(d)),"time")' )
     r_in( 'd1 = sapply(sgenes, function(s) rowSums(d[,colnames(d) == s,drop=FALSE]))' ),
     r_in( 'd0 = sapply(sgenes, function(s) sum(colnames(d) == s)) - d1' ).

:-
     ( current_r_session( _R ) -> true
          ;
          r_open, 
          G = [1-[2,3,4],2-[],3-[],4-[]],
          length( G, L ),
          r_in( m <- matrix(1,nrow=L,ncol=L) ),
          set_up_boutros
     ).

nem_mll( Nem, Mll) :-
     r_in( 'm[]' <- 0 ),
     % r_print( m ),
     push_nem( Nem ),
     % r_print( m ),
     % r_print( control ),
     %%% score <- 'score( m, d, control, verbose=FALSE )',

     %% score <- 'nem:::score( m, d, control, verbose=FALSE )',
     score <- 'nem:::mLL( m, d1, d0, control, verbose=FALSE )',
     % r_print( score ),
	% results <- sapply(models,mLL,D1,D0,control, verbose)     	   			
     % s       <- unlist(results["mLL",])

     Mll <- 'as.vector(score$mLL)'.

push_nem( [] ).
push_nem( [Ch-Pa|T] ) :-
     % ord_add_element( Pa, Ch, All ),
     push_pa( Pa, Ch ),
     % atomic_concat( ['m[,', Ch, ']'], M ),
     % r_in( M <- All ),
     push_nem( T ).

push_pa( [], Ch ) :-
     atomic_list_concat( ['m[',Ch,',',Ch,']'], M ),
     r_in( M <- 1 ).
push_pa( [H|T], Ch ) :-
     atomic_list_concat( ['m[',H,',',Ch,']'], M ),
     r_in( M <- 1 ),
     push_pa( T, Ch ).
