:- ensure_loaded( '../../auxil/all_models'  ).

all_models_of_true( [] ).
all_models_of_true( [H|T] ) :-
     atom_concat( H, '.slp', Hslp ),
     atom_concat( '../true/', Hslp, Slp ),
     true_has_num_vars( H, NumVars ),
     functor( VoidTerm, t, NumVars ),
     VoidTerm =.. [t|VarsList],
     atom_concat( stem_, H, Stem ),
     Opts = [
               slp(Slp),
               call(sample(VarsList),VarsList),
               rec( obs([obs,prb]) ), 
               stem(Stem)
     ],
     all_models( Opts ),
     all_models_of_true( T ).

true_has_num_vars( True, NumVars ) :-
     atom_concat( True, '_vrs.pl', Hrvs ),
     atom_concat( '../true/', Hrvs, RvsFile ),
     open( RvsFile, read, In ),
     read( In, Term1 ),
     true_stream_has_num_vars( Term1, In, NumVars ),
     close( In ).

true_stream_has_num_vars( num_rvs(NumVars), _In, NumVars ) :- !.
true_stream_has_num_vars( _Other, In, NumVars ) :-
     read( In, NextTerm ),
     true_stream_has_num_vars( NextTerm, In, NumVars ).
