:- ensure_loaded( '../../src/init_lib' ). % elm/1.
:- ensure_loaded( '../loss' ).
:- ensure_loaded( '../expected_loss' ). % /5,model_to_loss_structure/3.
:- ensure_loaded( true_abbrv_codes_to_true_name ).

chain_rerun_losses( [Stem] ) :-
% chain_bst_mst_to_losses( [Stem] ) :-
	atom_concat( 'cm_t', StemTail, Stem ),
	atom_codes( StemTail, [C1,C2|_] ),
	true_abbrv_codes_to_true_name( [C1,C2], TrueBn ),
	atom_concat( TrueBn, '_loss_info.pl', TrueFile ),
	atom_concat( 'compare/true/', TrueFile, ElmTrueFile ),
	elm( ElmTrueFile ),
	expected_loss( [loss_ck,loss_ks], 500, '../losses/', Stem, _ ),
	% expected_loss( [loss_ck,loss_ks,loss_naive_edgecount], 500, '../losses/', Stem, _ ),
	atom_concat( Stem, '_bst_mst.pl', BMFile ),
	open( BMFile, read, In ),
	read( In, bst_lgllhood(BMod,BLgL,BTms) ),
	read( In, mst_visited(MMod,MLgL,MTms) ),
	close( In ),
	findall( LossNm-LossId, loss_id(LossNm,LossId), LossPrs ),
	model_to_loss_structure( BMod, [], BLossStr ),
	all_losses_for( LossPrs, BLossStr, BLosses ),
	( BMod == MMod -> 
		MLosses = BLosses
		;
		model_to_loss_structure( MMod, [], MLossStr ),
		all_losses_for( LossPrs, MLossStr, MLosses )
	),
	atom_concat( Stem, '_reruns_bst_mst.pl', BMLFile ),
	atom_concat( '../losses/', BMLFile, LossBMFile ),
	open( LossBMFile, write, Out ),
	writeq( Out, bst_lgllhood_losses( BLosses,BLgL,BTms,BMod) ),
	write( Out , '.' ), nl( Out ),
	writeq( Out, mst_visited_losses( MLosses,MLgL,MTms,MMod) ),
	write( Out , '.' ), nl( Out ),
	close( Out ).

all_losses_for( [], _LossStr, [] ).
all_losses_for( [Name-Id|T], LossStr, MLosses ) :-
	Call =.. [Name,LossStr,StrLoss],
	call( Call ),
	StrContrib =.. [Id,StrLoss],
	MLosses = [StrContrib|TMLosses],
	all_losses_for( T, LossStr, TMLosses ).
