:- ensure_loaded( '../../src/init_lib' ).
:- requires( directory_files_regular/2 ).
:- requires( file_stems_of_files_with_this_ext/3 ).
:- requires( sys_info/1 ).

chains_to_bst_mst_losses :-
	directory_files_regular( '.', RegFiles ),
	file_stems_of_files_with_this_ext( RegFiles, '.gz', GzStems ),
	chain_files_to_bst_mst_losses_files( GzStems ).

chain_files_to_bst_mst_losses_files( [] ).
chain_files_to_bst_mst_losses_files( [HStem|TStems] ) :-
	atom_concat( HStem, '.gz', HGz ),
     atom_concat( 'upsh p chain_to_bst_mst ', HGz, UpshBstMst ),
	sys_info( UpshBstMst ),
	atom_concat( 'upsh p chain_bst_mst_to_losses ', HStem, UpshLosses ),
	sys_info( UpshLosses ),
	chain_files_to_bst_mst_losses_files( TStems ).
