:- ensure_loaded( ciex ).

% We assume Bn is keysorted pairs of Ch-Pa.
% APIs is a keysorted list of Nd1-Nd2, where Nd1 and Nd2 are independent.
% Nd1 @< Nd2.

all_pairwise_independencies( Bn, APIs ) :-
	all_nodes( Bn, Nodes ),
	all_node_pwise_independencies( Nodes, Bn, APIs, [] ).

all_node_pwise_independencies( [], _Bn, Tail, Tail ).
all_node_pwise_independencies( [H|T], Bn, APIs, Tail ) :-
	write( h(H) ), nl,
	all_independencies_for_node( T, H, Bn, APIs, Cont ),
	all_node_pwise_independencies( T, Bn, Cont, Tail ).

all_independencies_for_node( [], _Nd, _Bn, Tail, Tail ).
all_independencies_for_node( [H|T], Nd, Bn, APIs, Tail ) :-
	( ci([Nd],[H],[],Bn) ->
		APIs = [Nd-H|TAPIs]
		;
		TAPIs = APIs
	),
	all_independencies_for_node( T, Nd, Bn, TAPIs, Tail ).

all_nodes( [], [] ).
all_nodes( [H-_|T], [H|TNds] ) :-
	all_nodes( T, TNds ).
