% This script reproduces the run 2pu which is the left part of Fig. 7.
% Because of the evolution of the software, the results to this experiment
% are similar, rather than identical, to the one in the paper.
% To run do: 
% (a)   
%       run the experiment by starting a prolog (SICStus or Yap) and
%       compile( run_2pu_fig7_left )
%       run_2pu_fig7_left.
%       halt.
% (b)
%       cd into uai01_fig7l_2pu
%       start a prolog and execute
%       compile( '<mcmcms_top_dir>/bns/auxil/juxta_two_chains' ).
%       juxta_two_chains( 'fig7l_2pu_s1_vs_s40.dat' ).
%       halt.
% Given that you have gnuplot in your $PATH, a plot will automatically appear.
% At any event, the data for the plot will be stored in fig7l_2pu_s1_vs_s40.dat
% so the plot can be reproduced. For instance, use
% <mcmcms_top_dir>/bns/auxil/juxta_chains_plot fig7l_2pu_s1_vs_s40.dat

:- ensure_loaded( '../../run' ).
:- elm( 'bns/src/llhood/lhood_canonical_uai01' ).
:- elm( 'auxil/create_mvisits' ).


asia_data_full.
data_format(data(_,_,_,_,_,_,_,_)).
possible_values( _, [0,1] ).

run_2pu_fig7_left :-
	% Dir = '/local/d1p1/nicos/uai01_vs40/uai01_fig7l_2pu',
	Dir = uai01_fig7l_2pu,
	Runs = [
			runs_file( runs_2pu_fig7_left ),
		 	results_dir( Dir ),
			print([24,28,29])
		],
	run( Runs ).
