% This script reproduces the run 3po which is the right part of Fig. 6.
% Because of the evolution of the software, the results to this experiment
% are similar, rather than identical, to the one in the paper.
% To run do: 
% (a)   
%       run the experiment by starting a prolog (SICStus or Yap) and
%       compile( run_3po_fig6_right )
%       run_3po_fig6_right.
%       halt.
% (b)
%       cd into uai01_fig6r_3po
%       start a prolog and execute
%       compile( '<mcmcms_top_dir>/bns/auxil/juxta_two_chains' ).
%       juxta_two_chains( 'fig6r_3po_s1_vs_s40.dat' ).
%       halt.
% GIven that you have gnuplot in your $PATH, a plot will automatically appear.
% At any event, the data for the plot will be stored in fig6l_2po_s1_vs_s40.dat
% so the plot can be reproduced. For instance, use
% <mcmcms_top_dir>/bns/auxil/juxta_chains_plot fig6r_3po_s1_vs_s40.dat

:- ensure_loaded( '../../run' ).
:- elm( 'bns/src/llhood/lhood_canonical_uai01' ).
:- elm( 'auxil/create_mvisits' ).

asia_data_full.
data_format(data(_,_,_,_,_,_,_,_)).
possible_values( _, [0,1] ).

run_3po_fig6_right :-
	% Dir = '/local/d1p1/nicos/uai01/uai01_fig6r_3po',
	Dir = uai01_fig6r_3po,
	Runs = [
			runs_file( runs_3po_fig6_right ),
		 	results_dir( Dir ),
			print([24,28,29])
		],
	run( Runs ).
